#include "mbed.h"
#include "SDFileSystem.h"

SDFileSystem sd(PTE3, PTE1, PTE2, PTE4, "sd"); // MOSI, MISO, SCK, CS
Serial pc(USBTX, USBRX);
FILE *fp;
char buffer[1024];

int main() {
    pc.printf("Initializing \n");
    wait(2);

    fp = fopen("/sd/hello.txt", "r");
    if (fp != NULL) {
        fclose(fp);
        remove("/sd/hello.txt");
        pc.printf("Remove an existing file with the same name \n");
    }

    printf("\nWriting data to the sd card \n");
    fp = fopen("/sd/hello.txt", "w");
    if (fp == NULL) {
        pc.printf("Unable to write the file \n");
    } else {
        fprintf(fp, "mbed SDCard application!");
        fclose(fp);
        pc.printf("File successfully written! \n");
    }

    printf("\nReading data from the SD card. \n");
    fp = fopen("/sd/hello.txt", "r");
    if (fp != NULL) {
        int size = fread(buffer, sizeof(char), 1024, fp);
        printf("Number of data read: %d, text from hello.txt file: %s \n", size, buffer);
        fclose(fp);
    }
    printf("End of Lab 4. \n");
}
